%here the differential capacitances are calculated using numerical
%differentiation

conv    = 16.0217662;                       %converts e/(V*nm^2) to microF/(cm^2)

Psi     = [-0.2 0 0.2 0.4 0.6 0.8 1.2 2];        %potential difference in V

%surface charge density in e/(nm^2)
sigma   = [-0.6348193266462194 4.267708829927576E-4 0.6348193266462194 1.2350465828959933 1.9306584802668472 ...
           2.548209416062554 3.783687364759965 5.674907463646309];
       
[Cap,~] = numdiff(sigma, Psi);  %differential capacitance in e/(V*nm^2)

Cap2 = conv*Cap;                %differential capacitance in microF/(cm^2);

%save data to file
fileID = fopen('results_diff_cap_by_num_diff.txt','w');
fprintf(fileID, '%s %s\n' , 'Psi [v]', 'C_mu^Delta [microF/(cm^2)]');

formatSpec = '%f %f\n';
nrows = length(Psi);
for row = 1:nrows
    fprintf(fileID,formatSpec, Psi(row), Cap2(row));
end
fclose(fileID);
